﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class AIInput : MonoBehaviour {

    private Movement movement;

    private Vector2 movement_vector;

    private void Awake()
    {
        movement = GetComponent<Movement>();
        InvokeRepeating("MakeDecision", 1.0f, 1.0f);
    }


    private void Update()
    {
        SendMessage("Move", movement_vector);
    }

    private void MakeDecision()
    {
        List<DIRECTION> moves = new List<DIRECTION>();
        List<DIRECTION> valid_moves = new List<DIRECTION>();
        moves.Add(DIRECTION.UP);
        moves.Add(DIRECTION.DOWN);
        moves.Add(DIRECTION.LEFT);
        moves.Add(DIRECTION.RIGHT);

        for (int i = 0; i < moves.Count; i++)
        {
            if (movement.CheckValidDirection(moves[i], movement.raycast_distance))
                valid_moves.Add(moves[i]);
        }


        int random_idx = Random.Range(0, valid_moves.Count);

        print(valid_moves[random_idx]);

        movement_vector = DirectionToVector(valid_moves[random_idx]);

    }

    private Vector2 DirectionToVector(DIRECTION dir)
    {
        switch(dir)
        {
            case DIRECTION.UP:
                return new Vector2(0, 1);
            case DIRECTION.DOWN:
                return new Vector2(0, -1);
            case DIRECTION.LEFT:
                return new Vector2(-1, 0);
            case DIRECTION.RIGHT:
                return new Vector2(1, 0);
            default:
                return Vector2.zero;
        }
    }

}
